local function get_tweak_data_from_ammo_or_weapon(weapon, data, fallback)
    local weapon_factory = managers.weapon_factory
    local _blueprint = weapon._blueprint
    local part_id = weapon_factory:get_part_id_from_weapon_by_type("ammo", _blueprint)
    local part_data = nil

    if part_id then
        part_data = weapon_factory:get_part_data_by_part_id_from_weapon(part_id, weapon._factory_id, _blueprint)
    end

    return part_data and part_data[data] or weapon:weapon_tweak_data()[data] or fallback
end

Hooks:PostHook(GrenadeBase, "throw", "AirburstGrenades.throw", function (self)
    local weapon_unit = self:weapon_unit()

    if weapon_unit then
        local weapon = weapon_unit:base()
        local enable_airburst_grenades = get_tweak_data_from_ammo_or_weapon(weapon, "enable_airburst_grenades")

        if enable_airburst_grenades then
            self._enable_airburst_grenades = enable_airburst_grenades
            self._proximity_radius = get_tweak_data_from_ammo_or_weapon(weapon, "proximity_radius", 125)
        end
    end
end)

Hooks:PostHook(GrenadeBase, "update", "AirburstGrenades.update", function (self)
    if self._enable_airburst_grenades then
        local _unit = self._unit

        if alive(_unit) then
            local from = _unit:position()

            if _unit:raycast("ray", from, from + from:normalized(), "sphere_cast_radius", self._proximity_radius, "slot_mask", managers.slot:get_mask("enemies")) then
                self:_detonate()
            end
        end
    end
end)
